<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage PluginsModifier
 */

/**
 * Smarty replace modifier plugin
 * 
 * Type:     modifier<br>
 * Name:     filesize<br>
 * Purpose:  show the filesize of a file in kb, mb, gb etc...
 * 
 * @param string $ 
 * @return string 
 */
function smarty_modifier_filesize($size) {
    $size *= 1024;
    $bytes = $size;
    if ($bytes >= 1073741824) {
        $bytes = number_format($bytes / 1073741824, 2) . ' GB';
    } elseif ($bytes >= 1048576) {
        $bytes = number_format($bytes / 1048576, 2) . ' MB';
    } elseif ($bytes >= 1024) {
        $bytes = number_format($bytes / 1024, 2) . ' KB';
    } elseif ($bytes > 1) {
        $bytes = $bytes . ' bytes';
    } elseif ($bytes == 1) {
        $bytes = $bytes . ' byte';
    } else {
        $bytes = '0 bytes';
    }

    return $bytes;



//    $unit = 'MB';
//    if ((!$unit && $size >= 1 << 30) || $unit == "GB")
//        return number_format($size / (1 << 30), 2) . "GB";
//    if ((!$unit && $size >= 1 << 20) || $unit == "MB")
//        return number_format($size / (1 << 20), 0) . "MB";
//    if ((!$unit && $size >= 1 << 10) || $unit == "KB")
//        return number_format($size / (1 << 10), 2) . "KB";
//    return number_format($size) . " bytes";
}