<?php

class debugger {

    public $_file;
    public static $_defaultFile = 'kcd.log';
    public $_debug = DEBUG;
    public static $_Instance;

    function __construct($filename) {
        $this->_file = $filename;
        self::$_Instance = $this;
    }

    public function setFile($filename) {
        $this->_file = $filename;
    }

    public function getFile() {
        return $this->_file;
    }

    public function notice($data) {
        return $this->_write($data, 'notice');
    }

    public function clear() {
        $fp = fopen($this->_file, 'w+');
        if (!$fp) {
            return false;
        }
        return fwrite($fp, '') == true ? fclose($fp) : fclose($fp);
    }

    public function error($data) {
        return $this->_write($data, 'error');
    }

    public function warning($data) {
        return $this->_write($data, 'warning');
    }

    public function debug($data) {
        return $this->_write($data, 'debug');
    }

    private function _write($data, $level) {
        if ($this->_debug == false) {
            return false;
        }
        $fp = fopen($this->_file, 'a+');
        $has_data = false;
        while ($buffer = fread($fp, 2)) {
            if ($buffer == "]\n") {
                $has_data = true;
            }
        }
        if ($has_data == false) {
            $line = "[type],";
            $line .= "[date/time],";
            $line .= "[data],";
            $line .= "[file],";
            $line .= "[line],";
            $line .= "[class],";
            $line .= "[function]";

            $line .= "\n";
        } else {
            $line = '';
        }
        if (empty($data)) {
            $data = 'Null debug store request.';
        }
        $time = date('Y-m-d H:i:s', time());
        $debug = debug_backtrace();
        $line .= "[" . $level . "],";
        $line .= "[" . $time . "],";
        $line .= "[" . $data . "],";
        $line .= "[" . $debug[count($debug) - 1]['file'] . "],";
        $line .= "[" . $debug[count($debug) - 1]['line'] . "],";
        $line .= "[" . $debug[count($debug) - 1]['class'] . "],";
        $line .= "[" . $debug[count($debug) - 1]['function'] . "]";
        $line .= "\n";

        if (fwrite($fp, $line, strlen($line))) {
            fclose($fp);
            return true;
        } else {
            echo 'cant write to file' . "\n" . 'requested data to write : ' . "\n";
            echo $line;
        }
        fclose($fp);
    }

    private static function write($type, $message) {
        $obj = self::$_Instance;
        if (empty($obj->_file)) {
            throw new Exception('Debug file not available', 1);
        }
        switch ($type) {
            case 'notice':
                return $obj->notice($message);
            case 'error':
                return $obj->error($message);
            case 'warning':
                return $obj->warning($message);
            case 'debug':
                return $obj->debug($message);
            default:
                return false;
        }
    }

    public static function WriteNotice($message) {
        try {
            self::write('notice', $message);
            return true;
        } catch (Exception $ex) {
            if ($ex->getCode() == 1) {
                self::initObj();
            }
        }
        try {
            self::write('notice', $message);
            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

    public static function WriteWarning($message) {
        try {
            self::write('warning', $message);
            return true;
        } catch (Exception $ex) {
            if ($ex->getCode() == 1) {
                self::initObj();
            }
        }
        try {
            self::write('warning', $message);
            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

    public static function WriteError($message) {
        try {
            self::write('error', $message);
            return true;
        } catch (Exception $ex) {
            if ($ex->getCode() == 1) {
                self::initObj();
            }
        }
        try {
            self::write('error', $message);
            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

    public static function WriteDebug($message) {
        try {
            self::write('debug', $message);
            return true;
        } catch (Exception $ex) {
            if ($ex->getCode() == 1) {
                self::initObj();
            }
        }
        try {
            self::write('debug', $message);
            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

    public static function reload() {
        $obj = self::$_Instance;
        if (empty($obj->_file)) {
            self::initObj();
            unset($obj);
            $obj = self::$_Instance;
        }
        return $obj->clear();
    }

    private static function initObj() {
        $obj = new debugger(app_root . 'cache/' . self::$_defaultFile);
        return $obj;
    }

}
