<?php

class email {

    public static function test() {
        $config = config::load();
        $email_type = $config['email_type'];
        if ($email_type == 'php') {
            $transporter = Swift_MailTransport::newInstance();
        } else {
            $transporter = Swift_SmtpTransport::newInstance($config['email_host'], $config['email_port'], $config['email_enc'])
                    ->setUsername($config['email_username'])
                    ->setPassword($config['email_password']);
        }
        try {
            $transporter->start();
            return true;
        } catch (Exception $ex) {
            return false;
        }
    }

    public static function send($to, $subject, $body, $attach = NULL) {
        if (is_array($to)) {
            foreach ($to as $index => $tomail) {
                if (!validator::validate($tomail, 'email')) {
                    unset($to[$index]);
                }
            }
        } else {
            if (!validator::validate($to, 'email')) {
                return false;
            }
        }
        $config = config::load();
        $from = array($config['email_fromemail'] => $config['email_fromname']);
        $email_type = $config['email_type'];
        $bcc = explode(',', $config['email_bcc']);
        if ($email_type == 'php') {
            $transporter = Swift_MailTransport::newInstance();
        } else {
            $transporter = Swift_SmtpTransport::newInstance($config['email_host'], $config['email_port'], $config['email_enc'])
                    ->setUsername($config['email_username'])
                    ->setPassword($config['email_password']);
        }
        $mailer = Swift_Mailer::newInstance($transporter);
        $message = Swift_Message::newInstance($subject)
                ->setFrom($from)
                ->setTo($to)
                ->setBody($body, 'text/html', 'utf-8');
        if ($attach != NULL) {
            $message->attach(Swift_Attachment::fromPath($attach));
        }
        if (is_array($bcc)) {
            for ($i = 0; $i < count($bcc); $i++) {
                if ($bcc[$i] != "") {
                    $message->addBcc($bcc[$i]);
                }
            }
        }
        $failed = array();
        try {
            $mailer->send($message, $failed);
            return true;
        } catch (Swift_RfcComplianceException $e) {
            error::occur('Cannot Send e-mail : ' . $e->getMessage());
            return FALSE;
        }
    }

}
