<?php

class ftp {

    public $host;
    public $port;
    public $user;
    public $pass;
    public $dir;
    public $handler;
    public $timeout;

    public function __construct($host, $user, $pass, $dir, $port = 21, $timeout = 10) {
        $this->host = $host;
        $this->user = $user;
        $this->pass = $pass;
        $this->dir = $dir;
        $this->port = $port;
        $this->timeout = $timeout;
    }

    public function test() {
        $this->handler = ftp_connect($this->host, $this->port, $this->timeout);
        if (!$this->handler) {
            return $this->handler;
        }
        if (!ftp_login($this->handler, $this->user, $this->pass)) {
            return false;
        }
        // make a fake temp file to test upload 
        $file = tempnam(sys_get_temp_dir(), 'ftp.tmp');
        file_put_contents($file, 'Successfully written a temporary file. ');

        // now upload to FTP server and track for error
        if (ftp_put($this->handler, $this->dir . '/ftp.test', $file, FTP_BINARY)) {
            @unlink($file);
            return true;
        }
        @unlink($file);
        return false;
    }

    public function upload($file) {
        if (!file_exists($file)) {
            return false;
        }
        $this->handler = ftp_connect($this->host, $this->port, $this->timeout);
        if (!$this->handler) {
            return $this->handler;
        }
        if (!ftp_login($this->handler, $this->user, $this->pass)) {
            return false;
        }
        if (ftp_put($this->handler, $this->dir . basename($file), $file, FTP_BINARY)) {
            return true;
        }
        return false;
    }

}
