<?php

class tpl {

    public static function save($tpl, $html) {
        $count = ORM::for_table('emailtpl')->where('tpl', $tpl)->count();
        if ($count > 0) {
            $tbl = ORM::for_table('emailtpl')->where('tpl', $tpl)->find_one();
        } else {
            $tbl = ORM::for_table('emailtpl')->create();
        }
        $tbl->tpl = $tpl;
        $tbl->html = $html;
        try {
            $tbl->save();
            notice::occur('emailtpl_save_success');
            return true;
        } catch (Exception $ex) {
            error::occur('emailtpl_save_fail');
            return false;
        }
    }

    public static function load($tpl) {
        $tbl = ORM::for_table('emailtpl')->where('tpl', $tpl)->find_one();
        return (isset($tbl->html)) ? $tbl->html : false;
    }

    // data[0]['tag']
    // data[0]['data']
    public static function parse($tplname, $data) {
        $html = self::load($tplname);
        foreach ($data as $value) {
            $html = str_replace($value['tag'], $value['val'], $html);
        }
        return $html;
    }

    public static function make_forget_pass($username, $forget_pass_crypt, $level = 'admin') {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = template::host() . '/';
        $data[2]['tag'] = '{%forget_pass_crypt}';
        $data[2]['val'] = template::host() . '/' . $level . '/index.php?cmd=recover_pass&crypt=' . $forget_pass_crypt . '&username=' . $username;
        return tpl::parse('forget_pass', $data);
    }

    public static function make_sync_report($sync_total) {
        $available = cipher::IsLimited('user');
        $data[0]['tag'] = '{%sync_total}';
        $data[0]['val'] = $sync_total;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = app_url;
        $data[2]['tag'] = '{%user_limit_rem}';
        $data[2]['val'] = $available;
        return tpl::parse('sync_report', $data);
    }

    public static function make_changecredit_report($username, $amount, $action, $description) {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%amount}';
        $data[1]['val'] = $amount;
        $data[2]['tag'] = '{%action}';
        if ($action == '-') {
            $data[2]['val'] = 'از اعتبار شما کسر شد.';
        }
        if ($action == '+') {
            $data[2]['val'] = 'به اعتبار شما اضافه شد';
        }
        $data[3]['tag'] = '{%description}';
        $data[3]['val'] = $description;
        $data[4]['tag'] = '{%app_url}';
        $data[4]['val'] = template::host() . '/';
        return tpl::parse('changecredit', $data);
    }

    public static function make_newinvoice_report($username, $amount, $date, $description, $invoiceid) {
        $invoiceInfo = invoice::info_by_number($invoiceid);
        $level = $invoiceInfo['level'];
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%amount}';
        $data[1]['val'] = $amount;
        $data[2]['tag'] = '{%date}';
        $data[2]['val'] = $date;
        $data[3]['tag'] = '{%description}';
        $data[3]['val'] = $description;
        $data[4]['tag'] = '{%app_url}';
        $data[4]['val'] = template::host() . '/' . $level;
        $data[5]['tag'] = '{%invoiceid}';
        $data[5]['val'] = $invoiceid;
        $data[6]['tag'] = '{%level_string}';
        switch ($level) {
            case 'user':
                $data[6]['val'] = 'کاربری';
                break;
            case 'reseller':
                $data[6]['val'] = 'نمایندگی';
                break;
        }
        return tpl::parse('newinvoice', $data);
    }

    public static function make_invoicepaid_report($username, $amount, $description, $invoiceid, $transid, $gateway) {
        $invoiceInfo = invoice::info_by_number($invoiceid);
        $level = $invoiceInfo['level'];
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%amount}';
        $data[1]['val'] = $amount;
        $data[2]['tag'] = '{%gateway}';
        $data[2]['val'] = $gateway;
        $data[3]['tag'] = '{%description}';
        $data[3]['val'] = $description;
        $data[4]['tag'] = '{%app_url}';
        $data[4]['val'] = template::host() . '/' . $level;
        $data[5]['tag'] = '{%invoiceid}';
        $data[5]['val'] = $invoiceid;
        $data[6]['tag'] = '{%transid}';
        $data[6]['val'] = $transid;
        $data[7]['tag'] = '{%level_string}';
        switch ($level) {
            case 'user':
                $data[7]['val'] = 'کاربری';
                break;
            case 'reseller':
                $data[7]['val'] = 'نمایندگی';
                break;
        }
        return tpl::parse('invoicepaid', $data);
    }

    public static function make_shop_buy_report($username, $password) {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%password}';
        $data[1]['val'] = $password;
        $u_info = user::info_by_name($username);
        $p_info = package::info($u_info['package_id']);
        $data[2]['tag'] = '{%period}';
        $data[2]['val'] = $p_info['period'];
        $data[3]['tag'] = '{%app_url}';
        $data[3]['val'] = template::host() . '/';
        return tpl::parse('new_acc', $data);
    }

    public static function make_shop_renew_report($username, $password) {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%password}';
        $data[1]['val'] = $password;
        $u_info = user::info_by_name($username);
        $p_info = package::info($u_info['package_id']);
        $data[2]['tag'] = '{%period}';
        $data[2]['val'] = $p_info['period'];
        $data[3]['tag'] = '{%app_url}';
        $data[3]['val'] = template::host() . '/';
        return tpl::parse('renew_acc', $data);
    }

    public static function make_lock_report($username) {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = template::host() . '/';
        return tpl::parse('lock', $data);
    }

    public static function make_expiry_report($username) {
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%remdays}';
        $u_info = user::info_by_name($username);
        $seconds = strtotime($u_info['expire_date']) - time();
        $days = floor($seconds / 86400);
        $seconds %= 86400;
        $hours = floor($seconds / 3600);
        unset($s);
        if ($days > 0) {
            $s = $days . " روز";
        }
        if (isset($s)) {
            if ($hours > 0) {
                $s .= " و $hours ساعت";
            }
        } else {
            if ($hours > 0) {
                $s = "$hours ساعت";
            }
        }


        $data[1]['val'] = $s;
        $data[2]['tag'] = '{%expire_date}';
        $data[2]['val'] = jdate('Y-m-d H:i', strtotime($u_info['expire_date']));
        $data[3]['tag'] = '{%app_url}';
        $domain = user::userDomain($username) . '/';
        $data[3]['val'] = 'http://' . $domain;
        return tpl::parse('expiry', $data);
    }

    public static function make_ticket_new_report($username, $ticket_id, $level) {
        $ticket_info = ticket::info($ticket_id, $username);
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $level == 'guest' ? 'مشتری' : $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = template::host() . '/' . $level;
        $data[2]['tag'] = '{%subject}';
        $data[2]['val'] = $ticket_info['subject'];
        $data[3]['tag'] = '{%btn_name}';
        switch ($level) {
            case 'user':
                $data[3]['val'] = 'کاربری';
                break;
            case 'admin':
                $data[3]['val'] = 'مدیریت';
                break;
            case 'reseller':
                $data[3]['val'] = 'نمایندگی';
                break;
        }
        if ($level != 'guest') {
            $data[3]['val'] = 'ورود به محیط ' . $data[3]['val'];
            $data[4]['tag'] = '{%btn_url}';
            $data[4]['val'] = template::host() . '/' . $level;
        } else {
            $data[3]['val'] = 'مشاهده درخواست';
            $data[4]['tag'] = '{%btn_url}';
            $data[4]['val'] = template::host() . '/guest/?key=' . $ticket_info['uniqueid'] . '&email=' . $ticket_info['email'];
        }

        return tpl::parse('ticket_new', $data);
    }

    public static function make_ticket_reply_report($username, $ticket_id, $level) {
        $ticket_info = ticket::info_raw($ticket_id);
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $level == 'guest' ? 'مشتری' : $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = 'http://' . user::userDomain($username) . '/' . $level;
        $data[2]['tag'] = '{%subject}';
        $data[2]['val'] = $ticket_info['subject'];
        $data[3]['tag'] = '{%ticket_link}';
        $data[3]['val'] = $level == 'guest' ? template::host() . '/guest/?key=' . $ticket_info['uniqueid'] . '&email=' . $ticket_info['email'] : 'http://' . user::userDomain($username) . '/' . $level . '/?cmd=ticket&action=view&id=' . $ticket_id;
        $data[4]['tag'] = '{%btn_name}';
        switch ($level) {
            case 'user':
                $data[4]['val'] = 'کاربری';
                break;
            case 'admin':
                $data[4]['val'] = 'مدیریت';
                break;
            case 'reseller':
                $data[4]['val'] = 'نمایندگی';
                break;
        }
        if ($level != 'guest') {
            $data[4]['val'] = 'ورود به محیط ' . $data[4]['val'];
            $data[5]['tag'] = '{%btn_url}';
            $data[5]['val'] = template::host() . '/' . $level;
        } else {
            $data[4]['val'] = 'مشاهده درخواست';
            $data[5]['tag'] = '{%btn_url}';
            $data[5]['val'] = template::host() . '/guest/?key=' . $ticket_info['uniqueid'] . '&email=' . $ticket_info['email'];
        }
        return tpl::parse('ticket_reply', $data);
    }

    public static function notifyAdminNewTicket($ticket_id) {
        $ticket_info = ticket::info_raw($ticket_id);
        $html = '';
        $html .= '<p>';
        $html .= 'مدیر گرامی تیکت جدیدی با عنوان ';
        $html .= $ticket_info['subject'];
        $html .= ' ایجاد شده است٫ برای پاسخ ';
        $html .= '<a href="' . app_url . 'admin/?cmd=ticket&action=view&id=' . $ticket_id . '">اینجا</a>';
        $html .= ' کلیک نمایید';
        $html .= '</p>';
        $html .= '<p>';
        $html .= '<hr/>';
        $html .= 'متن درخواست : ';
        $html .= $ticket_info['body'];
        $html .= '</p>';
        $data[0]['tag'] = '{%system}';
        $data[0]['val'] = $html;
        return tpl::parse('system', $data);
    }

    public static function Backup() {
        $config = config::load();
        $html = '';
        $html .= '<p>';
        $html .= 'گزارش عملیات پشتیبان گیری از پایگاه اطلاعاتی';
        $html .= '<br/>';
        $hasaway = false;
        if ($config['backup_method_email'] == 1) {
            $hasaway = true;
            $html .= 'فایل پشتیبان به صورت ZIP به این ایمیل ضمیمه شد';
            $html .= '<br/>';
        }
        if ($config['backup_method_ftp'] == 1) {
            $hasaway = true;
            $html .= ' فایل پشتیبان به سرویس دهنده FTP منتقل شد ';
            $html .= '</p>';
        }
        if ($hasaway == false) {
            $html .= 'مدیر گرامی هیچ روش پشتیبان گیری تنظیم نشده , لطفا تنظیمات لازم را از پنل مدیریت انجام دهید';
            $html .= '</p>';
        }
        $data[0]['tag'] = '{%system}';
        $data[0]['val'] = $html;
        return tpl::parse('system', $data);
    }

    public static function TicketClosed($username, $ticket_id, $level) {
        $ticket_info = ticket::info_raw($ticket_id);
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $level == 'guest' ? 'مشتری' : $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = 'http://' . user::userDomain($username) . '/' . $level;
        $data[2]['tag'] = '{%subject}';
        $data[2]['val'] = $ticket_info['subject'];
        $data[3]['tag'] = '{%btn_name}';
        switch ($level) {
            case 'user':
                $data[3]['val'] = 'کاربری';
                break;
            case 'admin':
                $data[3]['val'] = 'مدیریت';
                break;
            case 'reseller':
                $data[3]['val'] = 'نمایندگی';
                break;
        }
        if ($level != 'guest') {
            $data[3]['val'] = 'ورود به محیط ' . $data[3]['val'];
            $data[4]['tag'] = '{%btn_url}';
            $data[4]['val'] = template::host() . '/' . $level;
        } else {
            $data[3]['val'] = 'مشاهده درخواست';
            $data[4]['tag'] = '{%btn_url}';
            $data[4]['val'] = template::host() . '/guest/?key=' . $ticket_info['uniqueid'] . '&email=' . $ticket_info['email'];
        }
        $data[5]['tag'] = '{%ticket_link}';
        $data[5]['val'] = $level == 'guest' ? template::host() . '/guest/?key=' . $ticket_info['uniqueid'] . '&email=' . $ticket_info['email'] : 'http://' . user::userDomain($username) . '/' . $level . '/?cmd=ticket&action=view&id=' . $ticket_id;
        return tpl::parse('ticket_close', $data);
    }

    public static function ResellerAdd($username) {
        $reseller_info = reseller::info_by_username($username);
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = template::host() . '/reseller';
        $data[2]['tag'] = '{%password}';
        $data[2]['val'] = $reseller_info['password'];

        switch ($reseller_info['credit']) {
            case 0:
                $string = 'برای خرید انلاین اعتبار از داخل پنل اقدام نمایید .';
                break;
            default:
                $string = 'اعتبار اولیه پنل شما ' . $reseller_info['credit'] . ' ریال  می باشد ٫ در صورت نیاز به اعتبار بیشتر از داخل پنل اقدام به خرید آنلاین نمایید٫ ';
                break;
        }
        $data[3]['tag'] = '{%credit_string}';
        $data[3]['val'] = $string;

        $data[4]['tag'] = '{%level_string}';
        $data[4]['val'] = 'نمایندگی';

        return tpl::parse('reseller_new', $data);
    }

    public static function InvoiceCancel($username, $invoiceid) {
        $invoiceInfo = invoice::info_by_number($invoiceid);
        $level = $invoiceInfo['level'];
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%amount}';
        $data[1]['val'] = $invoiceInfo['amount'];
        $data[2]['tag'] = '{%gateway}';
        $data[2]['val'] = $invoiceInfo['gateway'];
        $data[3]['tag'] = '{%description}';
        $data[3]['val'] = $invoiceInfo['description'];
        $data[4]['tag'] = '{%app_url}';
        $data[4]['val'] = template::host() . '/' . $level;
        $data[5]['tag'] = '{%invoiceid}';
        $data[5]['val'] = $invoiceid;
        $data[6]['tag'] = '{%transid}';
        $data[6]['val'] = $invoiceInfo['transaction'];
        $data[7]['tag'] = '{%level_string}';
        switch ($level) {
            case 'user':
                $data[7]['val'] = 'کاربری';
                break;
            case 'reseller':
                $data[7]['val'] = 'نمایندگی';
                break;
        }
        return tpl::parse('invoice_cancel', $data);
    }

    public static function SyncFail($needed) {
        $html = '';
        $html .= '<p>';
        $html .= 'عملیات همسان سازی متوقف شد.';
        $html .= '<br/>';
        $html .= 'تعداد کاربران مجاز شما کمتر از ' . $needed . ' کاربر می باشد ٫ جهت ارتقای بسته خود به وب سایت مراجعه نمایید.';
        $html .= '<br/>';
        $html .= '<table>
                                        <tr>
                                            <td class="padding">
                                                <p><a href="http://persistpanel.com/upgrade/" class="btn-primary">مشاهده بسته ها</a></p>
                                            </td>
                                        </tr>
                                    </table>';
        $html .= '</p>';
        $data[0]['tag'] = '{%system}';
        $data[0]['val'] = $html;
        return tpl::parse('system', $data);
    }

    public static function ResellerInfo($username) {
        $reseller_info = reseller::info_by_username($username);
        $data[0]['tag'] = '{%username}';
        $data[0]['val'] = $username;
        $data[1]['tag'] = '{%app_url}';
        $data[1]['val'] = template::host() . '/reseller';
        $data[2]['tag'] = '{%password}';
        $data[2]['val'] = $reseller_info['password'];
        $data[3]['val'] = $string;

        $data[4]['tag'] = '{%level_string}';
        $data[4]['val'] = 'نمایندگی';

        return tpl::parse('reseller_login_info', $data);
    }

    public static function NewTrans($invoice_number, $gateway, $result, $trans_id) {
        $html = '';
        $html .= '<p>';
        $html .= 'تراکنش جدیدی توسط درگاه پرداخت ';
        $html .= $gateway;
        $html .= ' انجام شد';
        $html .= '<br/>';
        $html .= 'وضعیت تراکنش : ';
        $html .= $result == true ? 'موفق' : 'نا موفق';
        $html .= '<br/>';
        $html .= 'شماره تراکنش : ';
        $html .= $trans_id;
        $html .= '<br/>';
        $html .= 'شماره فاکتور : ';
        $html .= '#' . $invoice_number;
        $html .= '<br/>';
        $html .= '<table>
                                        <tr>
                                            <td class="padding">
                                                <p><a href="' . template::host() . '/admin/?cmd=invoice#list" class="btn-primary">مشاهده فاکتور ها</a></p>
                                            </td>
                                        </tr>
                                    </table>';
        $html .= '</p>';
        $data[0]['tag'] = '{%system}';
        $data[0]['val'] = $html;
        return tpl::parse('system', $data);
    }

}
