<?php

class sibapal {

    public static function info() {
        $info['pic'] = self::pic();
        $info['author'] = 'persist';
        $info['description'] = 'درگاه پرداخت سیباپال';
        $info['type'] = 'payment';
        return $info;
    }

    public static function pic() {
        $classname = __CLASS__;
        return app_url . 'modules/' . $classname . '/sibapal.png';
    }

    public static function install() {
        $o_template = template::$instance;
        $smarty = $o_template->smarty;
        $tpl_dir = app_root . 'modules/' . __CLASS__ . '/template/';
        return $smarty->fetch($tpl_dir . 'install.tpl');
    }

    public static function setting() {
        $o_template = template::$instance;
        $smarty = $o_template->smarty;
        $tpl_dir = app_root . 'modules/' . __CLASS__ . '/template/';
        return $smarty->fetch($tpl_dir . 'setting.tpl');
    }

    public static function description() {
        $o_template = template::$instance;
        $smarty = $o_template->smarty;
        $tpl_dir = app_root . 'modules/' . __CLASS__ . '/template/';
        return $smarty->fetch($tpl_dir . 'description.tpl');
    }

    public static function request($amount, $desc) {
        $module_info_db = module::info_data(__CLASS__);
        $pin = $module_info_db['data']['key'];
        $price = $amount / 10;
        $callback = 'http://' . filter_input(INPUT_SERVER, 'HTTP_HOST') . '/payment.php';
        $id = NULL;
        $bank = NULL;
        $phone = 0;
        $client = new nusoap_client("https://www.sibapal.com/payment/wsdl?wsdl", 'wsdl');
        $res = $client->call('request', array($pin, $price, $callback, $id, $desc, $bank, $phone));

        if (strlen($res) < 3) {
            error::occur('Error : ' . $res . ' on module : ' . __CLASS__);
            return false;
        }
        return "https://www.sibapal.com/pay?au=" . $res;
    }

    public static function verify($amount, &$trans_id) {
        $module_info_db = module::info_data(__CLASS__);
        $pin = $module_info_db['data']['key'];
        $price = $amount / 10;
        $au = filter_input(INPUT_GET, 'au');
        $trans_id = $au;
        $client = new nusoap_client("https://www.sibapal.com/payment/wsdl?wsdl", 'wsdl');
        $result = $client->call('verify', array($pin, $price, $_GET["au"]));

        $err = array();
        $err[-20] = 'شناسه درگاه نامعتبر است';
        $err[-21] = 'آی پی نامعتبر است';
        $err[-22] = 'مبلغ از کف تعریف شده کمتر است';
        $err[-23] = 'مبلغ از سقف تعریف شده بیشتر است';
        $err[-24] = 'مبلغ نامعتبر است';
        $err[-6] = 'ارتباط با بانک برقرار نشد';
        $err[-26] = 'درگاه غیرفعال است';
        $err[-27] = 'آی پی شما مسدود است';
        $err[-9] = 'خطای ناشناخته';
        $err[-29] = 'آدرس کال بک خالی است ';
        $err[-30] = 'چنین تراکنشی یافت نشد';
        $err[-31] = 'تراکنش انجام نشده ';
        $err[-32] = 'تراکنش انجام شده اما مبلغ نادرست است ';
        $err[-35] = 'شماره order_id نامعتبر است !';
        $err[-36] = 'پارامترهاي ارسالي بانکي نامعتبر هستند';
        $err[-38] = 'شده است verify تراکنش قبلا یکبار';

        error::occur($err[$result]);
        //$err[1] = 'تراکنش با موفقیت انجام شده است';

        if (!empty($result) and $result == 1) {
            return true;
        } else {
            error::occur($err[$result]);
            return false;
        }
    }

}
