/*
 Navicat Premium Data Transfer

 Source Server         : Local P
 Source Server Type    : MySQL
 Source Server Version : 50173
 Source Host           : localhost
 Source Database       : persistInstall

 Target Server Type    : MySQL
 Target Server Version : 50173
 File Encoding         : utf-8

 Date: 09/14/2015 17:01:13 PM
*/

SET NAMES utf8;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
--  Table structure for `admins`
-- ----------------------------
DROP TABLE IF EXISTS `admins`;
CREATE TABLE `admins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `lastlogin` timestamp NULL DEFAULT NULL,
  `passreq_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `passreq` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `config`
-- ----------------------------
DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ibs_host` varchar(255) DEFAULT NULL,
  `ibs_port` int(4) DEFAULT '80',
  `ibs_user` varchar(255) DEFAULT NULL,
  `ibs_pass` varchar(255) DEFAULT NULL,
  `ibs_timeout` int(2) DEFAULT NULL,
  `shop_name` varchar(255) DEFAULT NULL,
  `shop_title` varchar(255) DEFAULT NULL,
  `shop_block` text,
  `shop_logo` text,
  `shop_timezone` varchar(255) DEFAULT NULL,
  `shop_template` varchar(255) DEFAULT NULL,
  `shop_default_payment` varchar(255) DEFAULT NULL,
  `shop_keyword` text,
  `shop_row_per_page` int(3) DEFAULT NULL,
  `shop_alert_renew` int(3) DEFAULT NULL,
  `shop_req_email_shop` int(1) DEFAULT NULL,
  `shop_req_email_reseller` int(1) DEFAULT NULL,
  `shop_chars_pass` text,
  `shop_chars_user` text,
  `shop_user_len` int(2) DEFAULT NULL,
  `shop_pass_len` int(2) DEFAULT NULL,
  `shop_illegal_username` text,
  `shop_null_prefix` int(1) DEFAULT NULL,
  `shop_reseller_empty_credit` int(1) DEFAULT NULL,
  `shop_reseller_no_gateway` int(1) DEFAULT NULL,
  `shop_reseller_default_admin_logo` int(1) DEFAULT NULL,
  `shop_min_deposit` int(11) DEFAULT NULL,
  `shop_monitor_interval` int(3) DEFAULT NULL,
  `email_type` varchar(255) DEFAULT NULL,
  `email_fromname` varchar(255) DEFAULT NULL,
  `email_fromemail` varchar(255) DEFAULT NULL,
  `email_host` varchar(255) DEFAULT NULL,
  `email_port` int(4) DEFAULT NULL,
  `email_username` varchar(255) DEFAULT NULL,
  `email_password` varchar(255) DEFAULT NULL,
  `email_enc` varchar(255) DEFAULT NULL,
  `email_bcc` text,
  `license` varchar(10) DEFAULT NULL,
  `backup_cron` varchar(255) DEFAULT NULL,
  `backup_method_email` int(1) DEFAULT NULL COMMENT '11 means checked email and checked ftp 01 means unchecked email and checked ftp',
  `backup_method_ftp` int(1) DEFAULT NULL,
  `backup_email_address` text,
  `backup_ftp_host` varchar(255) DEFAULT NULL,
  `backup_ftp_user` varchar(255) DEFAULT NULL,
  `backup_ftp_pass` varchar(255) DEFAULT NULL,
  `backup_ftp_dir` varchar(255) DEFAULT NULL,
  `version` varchar(255) DEFAULT NULL,
  `live` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
--  Records of `config`
-- ----------------------------
BEGIN;
INSERT INTO `config` VALUES ('1', '', '80', 'system', '', '30', '', '', '', '/var/admins/persist.png', 'Asia/Tehran', 'default', 'random', '', '10', '3', '0', '0', '!,@,#,$,%,^,&,*,(,)', '-,_,.', '4', '6', 'persis,banuser,admin,root,moderator,modir', '0', '1', '1', '1', '100000', '10', 'php', '', '', '', '0', '', '', '', '', '', '24', '1', '0', '', '', '', '', '', 'RC1.0.0', 'a:6:{s:4:\"live\";s:7:\"RC1.0.0\";s:4:\"risk\";s:7:\"feature\";s:4:\"link\";s:28:\"www.persistpanel.com/update/\";s:3:\"cmd\";s:7:\"version\";s:6:\"result\";b:1;s:7:\"message\";b:0;}');
COMMIT;

-- ----------------------------
--  Table structure for `credit_history`
-- ----------------------------
DROP TABLE IF EXISTS `credit_history`;
CREATE TABLE `credit_history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `comment` text,
  `reseller_id` int(11) DEFAULT NULL,
  `amount` int(11) DEFAULT NULL,
  `operation` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `domain`
-- ----------------------------
DROP TABLE IF EXISTS `domain`;
CREATE TABLE `domain` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain` varchar(255) DEFAULT NULL,
  `level` varchar(255) DEFAULT 'admin',
  `username` varchar(255) DEFAULT '0',
  `template` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `emailtpl`
-- ----------------------------
DROP TABLE IF EXISTS `emailtpl`;
CREATE TABLE `emailtpl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tpl` varchar(255) DEFAULT NULL,
  `html` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=latin1;

-- ----------------------------
--  Records of `emailtpl`
-- ----------------------------
BEGIN;
INSERT INTO `emailtpl` VALUES ('1', 'forget_pass', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø§ÛŒÙ† Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ ØµÙˆØ±Øª Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ø¯Ø± Ù¾Ø§Ø³Ø® Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØºÛŒÛŒØ± Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡\r\n                                        <br/>\r\n                                        Ø¯Ø± ØµÙˆØ±ØªÛŒ Ú©Ù‡ Ø§ÛŒÙ† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø² Ø·Ø±Ù Ø´Ù…Ø§ Ù†Ø¨ÙˆØ¯Ù‡ Ø§Ø³ØªØŒ Ø§Ø­ØªÛŒØ§Ø¬ Ø¨Ù‡ Ù‡ÛŒÚ† Ø¹Ù…Ù„ÛŒ Ù†ÛŒØ³Øª\r\n                                        <br/>\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯ Ø±ÙˆÛŒ Ù„ÛŒÙ†Ú© Ø²ÛŒØ± Ú©Ù„ÛŒÚ© Ù†Ù…ÙˆØ¯Ù‡ Ùˆ ÛŒØ§ Ø¢Ø¯Ø±Ø³ Ø²ÛŒØ± Ø±Ø§ Ø¯Ø± Ù…Ø±ÙˆØ±Ú¯Ø± Ø®ÙˆØ¯ ÙˆØ§Ø±Ø¯ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                        <code>\r\n                                            {%forget_pass_crypt}\r\n                                        </code>\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%forget_pass_crypt}\" class=\"btn-primary\"> Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('2', 'new_acc', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¨Ø§ ØªØ´Ú©Ø± Ø§Ø² Ø®Ø±ÛŒØ¯ Ø´Ù…Ø§Ù« Ù…Ø´Ø®ØµØ§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³Ø±ÙˆÛŒØ³ :â€Œ\r\n                                        <br/>\r\n                                        <br/>\r\n                                        \r\n                                        Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ : {%username}\r\n                                        <br/>\r\n                                        Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± : {%password}\r\n                                        <br/>\r\n                                        Ø¯ÙˆØ±Ù‡ Ø³Ø±ÙˆÛŒØ³ :â€Œ{%period} Ø±ÙˆØ² \r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¬Ù‡Øª ØªÙ…Ø¯ÛŒØ¯ , Ø¯Ø§Ù†Ù„ÙˆØ¯ , Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÙˆÛŒØ³ Ùˆ Ù‡Ù…Ú†Ù†ÛŒÙ† Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ÙˆØ§Ø±Ø¯ Ù¾Ù†Ù„ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø®ÙˆØ¯ Ø´ÙˆÛŒØ¯.\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}user/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· Ú©Ø§Ø±Ø¨Ø±ÛŒ</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('3', 'sync_report', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>Ú¯Ø²Ø§Ø±Ø´ Ù‡Ù…Ø³Ø§Ù† Ø³Ø§Ø²ÛŒ Ú©Ø§Ø±Ø¨Ø±Ø§Ù†</p>\r\n                                    <p>\r\n                                        Ù…Ø¯ÛŒØ± Ú¯Ø±Ø§Ù…ÛŒ Ù« {%sync_total} Ú©Ø§Ø±Ø¨Ø± Ø§Ø² ØµÙ Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ù‡Ù…Ø³Ø§Ù† Ø³Ø§Ø²ÛŒ Ø´Ø¯.\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§ Ù…ÛŒØªÙˆØ§Ù†ÛŒØ¯ {%user_limit_rem} Ú©Ø§Ø±Ø¨Ø± Ø¯ÛŒÚ¯Ø± Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ú©Ø§Ù…Ù„ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯\r\n                                    </p>\r\n\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/admin/?cmd=sync#queue\" class=\"btn-primary\">Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ù‡Ù…Ø³Ø§Ù† Ø³Ø§Ø²ÛŒ</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('4', 'changecredit', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø§Ø¹ØªØ¨Ø§Ø± Ø±ÛŒØ§Ù„ÛŒ Ù¾Ù†Ù„ Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ Ø´Ù…Ø§ ØªØºÛŒÛŒØ± ÛŒØ§ÙØª Ù« \r\n                                    </p>\r\n                                    <p>\r\n                                        Ù…Ø¨Ù„Øº {%amount} Ø±ÛŒØ§Ù„ {%action}\r\n                                    </p>\r\n                                    <p>\r\n                                        ØªÙˆØ¶ÛŒØ­Ø§Øª : {%description}\r\n                                    </p>\r\n\r\n\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/reseller/?cmd=credit&action=history\" class=\"btn-primary\">Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª</a></p>\r\n                                            </td>\r\n\r\n                                        </tr>\r\n                                    </table>\r\n\r\n                                    <hr/>\r\n                                    <p>\r\nØ¬Ù‡Øª Ø§ÛŒØ¬Ø§Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù« ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ù« Ù„ÛŒØ³Øª Ú©Ø§Ø¨Ø±Ø§Ù† Ù…Ù†Ù‚Ø¶ÛŒ Ùˆ Ø§ÛŒØ¬Ø§Ø¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§Ø®ØªØµØ§ØµÛŒ ÙˆØ§Ø±Ø¯ Ù…Ø­ÛŒØ· Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ Ø´ÙˆÛŒØ¯\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>'), ('5', 'newinvoice', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        ÙØ§Ú©ØªÙˆØ± Ø¬Ø¯ÛŒØ¯ÛŒ Ø¨Ù‡ Ù…Ø¨Ù„Øº {%amount} Ø±ÛŒØ§Ù„ Ø¯Ø± ØªØ§Ø±ÛŒØ® \r\n                                        <span dir=\"rtl\">{%date}</span>\r\n                                        Ø¨Ø±Ø§ÛŒ Ø´Ù…Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª Ù« Ù„Ø·ÙØ§ Ø¨Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ Ù…Ø§ Ø±Ø§ Ø¯Ø± Ø³Ø±ÙˆÛŒØ³ Ø¯Ù‡ÛŒ Ø¨Ù‡ØªØ± ÛŒØ§Ø±ÛŒ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ø±Ø­ ÙØ§Ú©ØªÙˆØ± : {%description}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± : {%invoiceid}\r\n                                    </p>\r\n\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/?cmd=invoice&action=unpaid\" class=\"btn-primary\">Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±</a></p>\r\n                                            </td>\r\n\r\n                                        </tr>\r\n                                    </table>\r\n\r\n                                    <hr/>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· {%level_string}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('6', 'invoicepaid', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¨Ø§ ØªØ´Ú©Ø± Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ù…Ø§ Ù« Ù…Ø´Ø®ØµØ§Øª ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø² Ù‚Ø¨ÛŒÙ„ Ø°ÛŒÙ„ Ù…ÛŒØ¨Ø§Ø´Ø¯ : \r\n                                    </p>\r\n                                    <p>\r\n                                        Ù…Ø¨Ù„Øº ÙØ§Ú©ØªÙˆØ± : {%amount} Ø±ÛŒØ§Ù„\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± : {%invoiceid}#\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ø±Ø­ ÙØ§Ú©ØªÙˆØ± : {%description}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§Ø±Ù‡ ØªØ±Ø§Ú©Ù†Ø´ : {%transid}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¯Ø±Ú¯Ø§Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª : {%gateway}\r\n                                    </p>\r\n\r\n                                    <hr/>\r\n                                    <p>\r\n                                        Ø¬Ù‡Øª ØªÙ…Ø¯ÛŒØ¯ , Ø¯Ø§Ù†Ù„ÙˆØ¯ , Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÙˆÛŒØ³ Ùˆ Ù‡Ù…Ú†Ù†ÛŒÙ† Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ÙˆØ§Ø±Ø¯ Ù¾Ù†Ù„ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø®ÙˆØ¯ Ø´ÙˆÛŒØ¯.\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· {%level_string}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('7', 'renew_acc', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¨Ø§ ØªØ´Ú©Ø± Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ù…Ø§ Ù« Ø³Ø±ÙˆÛŒØ³ Ø´Ù…Ø§ ØªÙ…Ø¯ÛŒØ¯ Ø´Ø¯ Ù« Ù…Ø´Ø®ØµØ§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³Ø±ÙˆÛŒØ³ :â€Œ\r\n                                        <br/>\r\n                                        <br/>\r\n                                        \r\n                                        Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ : {%username}\r\n                                        <br/>\r\n                                        Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± : {%password}\r\n                                        <br/>\r\n                                        Ø¯ÙˆØ±Ù‡ Ø³Ø±ÙˆÛŒØ³ :â€Œ{%period} Ø±ÙˆØ² \r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¬Ù‡Øª ØªÙ…Ø¯ÛŒØ¯ , Ø¯Ø§Ù†Ù„ÙˆØ¯ , Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÙˆÛŒØ³ Ùˆ Ù‡Ù…Ú†Ù†ÛŒÙ† Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ÙˆØ§Ø±Ø¯ Ù¾Ù†Ù„ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø®ÙˆØ¯ Ø´ÙˆÛŒØ¯.\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}user/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· Ú©Ø§Ø±Ø¨Ø±ÛŒ</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('8', 'lock', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø³Ø±ÙˆÛŒØ³ Ø´Ù…Ø§ ØªÙˆØ³Ø· Ù…Ø¯ÛŒØ± Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ù« Ø¨Ø±Ø§ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø§Ø² Ù…Ø­ÛŒØ· Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}user/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· Ú©Ø§Ø±Ø¨Ø±ÛŒ</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n');
INSERT INTO `emailtpl` VALUES ('9', 'expiry', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¯ÙˆØ±Ù‡ Ø³Ø±ÙˆÛŒØ³ Ø´Ù…Ø§ Ø¨Ø¹Ø¯ Ø§Ø² {%remdays} ØªÙ…Ø§Ù… Ù…ÛŒØ´ÙˆØ¯ Ù« Ù„Ø·ÙØ§ Ø¬Ù‡Øª ØªÙ…Ø¯ÛŒØ¯ Ø³Ø±ÙˆÛŒØ³ Ø§Ù‚Ø¯Ø§Ù… Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                    </p>\r\n<p>\r\nØªØ§Ø±ÛŒØ® Ø§Ù†Ù‚Ø¶Ø§ :â€Œ\r\n<span style=\"direction: ltr;display: inline-block;\">{%expire_date}</span>\r\n</p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}user/?cmd=renew\" class=\"btn-primary\">ØªÙ…Ø¯ÛŒØ¯ Ø¢Ù†Ù„Ø§ÛŒÙ† Ø³Ø±ÙˆÛŒØ³</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>'), ('10', 'ticket_new', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù† {%subject} Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª\r\n                                        <br/>\r\n                                        Ù…Ø§ Ø¨Ù‡ Ø´Ù…Ø§ Ø§ÛŒÙ† Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø±Ø§ Ù…ÛŒØ¯Ù‡ÛŒÙ… Ú©Ù‡ ÛŒÚ©ÛŒ Ø§Ø² Ø¹Ø§Ù…Ù„ÛŒÙ† Ø±Ø³ÛŒØ¯Ú¯ÛŒ Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ Ø¨Ù‡ Ø´Ù…Ø§ Ù¾Ø§Ø³Ø® Ø®ÙˆØ§Ù‡Ø¯ Ø¯Ø§Ø¯ Ù« Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¬Ø¯ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ø±Ø§Ø¨Ø·Ù‡ Ø®ÙˆØ¯ Ø¯Ø§Ø±ÛŒ Ù†Ù…Ø§ÛŒÛŒØ¯\r\n                                        <br/>\r\n                                        ØªÙ…Ø§Ù…ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÛŒ Ù¾Ø§Ø³Ø® Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Û´Û¸ Ø³Ø§Ø¹Øª Ø¨Ø³ØªÙ‡ Ù…ÛŒØ´ÙˆÙ†Ø¯ Ù« Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø§ÙÛŒØ³Øª Ù¾Ø§Ø³Ø®ÛŒ Ø§Ø±Ø³Ø§Ù„ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%btn_url}\" class=\"btn-primary\">{%btn_name}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('11', 'ticket_reply', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù† {%subject} Ù¾Ø§Ø³Ø® Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª\r\n                                        <br/>\r\n                                        Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù¾Ø§Ø³Ø® \r\n                                        <a href=\"{%ticket_link}\">\r\n                                            Ø§ÛŒÙ†Ø¬Ø§\r\n                                        </a>\r\n                                         Ú©Ù„ÛŒÚ© Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                        ØªÙ…Ø§Ù…ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÛŒ Ù¾Ø§Ø³Ø® Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Û´Û¸ Ø³Ø§Ø¹Øª Ø¨Ø³ØªÙ‡ Ù…ÛŒØ´ÙˆÙ†Ø¯ Ù« Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø§ÙÛŒØ³Øª Ù¾Ø§Ø³Ø®ÛŒ Ø§Ø±Ø³Ø§Ù„ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%btn_url}\" class=\"btn-primary\">{%btn_name}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('12', 'system', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    {%system}\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('13', 'ticket_close', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù† {%subject} Ø¨Ø³ØªÙ‡ Ø´Ø¯.\r\n                                        <br/>\r\n                                        Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ Ø§Ø±Ø³Ø§Ù„ Ù¾Ø§Ø³Ø®  \r\n                                        <a href=\"{%ticket_link}\">\r\n                                            Ø§ÛŒÙ†Ø¬Ø§\r\n                                        </a>\r\n                                         Ú©Ù„ÛŒÚ© Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                        ØªÙ…Ø§Ù…ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÛŒ Ù¾Ø§Ø³Ø® Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Û´Û¸ Ø³Ø§Ø¹Øª Ø¨Ø³ØªÙ‡ Ù…ÛŒØ´ÙˆÙ†Ø¯ Ù« Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø§ÙÛŒØ³Øª Ù¾Ø§Ø³Ø®ÛŒ Ø§Ø±Ø³Ø§Ù„ Ù†Ù…Ø§ÛŒÛŒØ¯.\r\n                                        <br/>\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%btn_url}\" class=\"btn-primary\">{%btn_name}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>'), ('14', 'reseller_new', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                                                        <p>\r\n                                        Ù¾Ù†Ù„ Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ Ø´Ù…Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ùˆ Ø§Ù…Ø§Ø¯Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø³Øª Ù« {%credit_string}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ù…Ø´Ø®ØµØ§Øª ÙˆØ±ÙˆØ¯ \r\n                                        <br/>\r\n                                        Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ : {%username}\r\n                                        <br/>\r\n                                        Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± : {%password}\r\n                                    </p>\r\n                                    <hr/>\r\n                                    <p>\r\nØ¬Ù‡Øª Ø§ÛŒØ¬Ø§Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù« ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ù« Ù„ÛŒØ³Øª Ú©Ø§Ø¨Ø±Ø§Ù† Ù…Ù†Ù‚Ø¶ÛŒ Ùˆ Ø§ÛŒØ¬Ø§Ø¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§Ø®ØªØµØ§ØµÛŒ ÙˆØ§Ø±Ø¯ Ù…Ø­ÛŒØ· {%level_string} Ø´ÙˆÛŒØ¯\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· {%level_string}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('15', 'invoice_cancel', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                    <p>\r\n                                        ÙØ§Ú©ØªÙˆØ± Ø´Ù…Ø§Ø±Ù‡ {%invoiceid}# Ù„ØºÙˆ Ø´Ø¯ Ù« Ø¬Ø²Ø¦ÛŒØ§Øª ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡ Ø´Ø±Ø­ Ø²ÛŒØ± Ù…ÛŒ Ø¨Ø§Ø´Ø¯.\r\n                                    </p>\r\n                                    <p>\r\n                                        Ù…Ø¨Ù„Øº ÙØ§Ú©ØªÙˆØ± : {%amount} Ø±ÛŒØ§Ù„\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± : {%invoiceid}#\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ø±Ø­ ÙØ§Ú©ØªÙˆØ± : {%description}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø´Ù…Ø§Ø±Ù‡ ØªØ±Ø§Ú©Ù†Ø´ : {%transid}\r\n                                    </p>\r\n                                    <p>\r\n                                        Ø¯Ø±Ú¯Ø§Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª : {%gateway}\r\n                                    </p>\r\n\r\n                                    <hr/>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}/\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· {%level_string}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>\r\n'), ('16', 'reseller_login_info', '<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n    <head>\r\n        <meta name=\"viewport\" content=\"width=device-width\" />\r\n        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n        <title></title>\r\n        <style>\r\n            /* -------------------------------------\r\n                            GLOBAL\r\n            ------------------------------------- */\r\n            * {\r\n                margin: 0;\r\n                padding: 0;\r\n                font-family: \"tahoma\", \"Helvetica\", Helvetica, Arial, sans-serif;\r\n                font-size: 100%;\r\n                line-height: 1.6;\r\n                direction: rtl;\r\n            }\r\n\r\n            img {\r\n                max-width: 100%;\r\n            }\r\n\r\n            body {\r\n                -webkit-font-smoothing: antialiased;\r\n                -webkit-text-size-adjust: none;\r\n                width: 100%!important;\r\n                height: 100%;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            ELEMENTS\r\n            ------------------------------------- */\r\n            a {\r\n                color: #348eda;\r\n            }\r\n\r\n            .btn-primary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #348eda;\r\n                border: solid #348eda;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .btn-secondary {\r\n                text-decoration: none;\r\n                color: #FFF;\r\n                background-color: #aaa;\r\n                border: solid #aaa;\r\n                border-width: 10px 20px;\r\n                line-height: 2;\r\n                font-weight: bold;\r\n                margin-right: 10px;\r\n                text-align: center;\r\n                cursor: pointer;\r\n                display: inline-block;\r\n                border-radius: 25px;\r\n            }\r\n\r\n            .last {\r\n                margin-bottom: 0;\r\n            }\r\n\r\n            .first {\r\n                margin-top: 0;\r\n            }\r\n\r\n            .padding {\r\n                padding: 10px 0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            BODY\r\n            ------------------------------------- */\r\n            table.body-wrap {\r\n                width: 100%;\r\n                padding: 20px;\r\n            }\r\n\r\n            table.body-wrap .container {\r\n                border: 1px solid #f0f0f0;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            FOOTER\r\n            ------------------------------------- */\r\n            table.footer-wrap {\r\n                width: 100%;	\r\n                clear: both!important;\r\n            }\r\n\r\n            .footer-wrap .container p {\r\n                font-size: 12px;\r\n                color: #666;\r\n\r\n            }\r\n\r\n            table.footer-wrap a {\r\n                color: #999;\r\n            }\r\n\r\n\r\n            /* -------------------------------------\r\n                            TYPOGRAPHY\r\n            ------------------------------------- */\r\n            h1, h2, h3 {\r\n                font-family: \"Helvetica Neue\", Helvetica, Arial, \"Lucida Grande\", sans-serif;\r\n                line-height: 1.1;\r\n                margin-bottom: 15px;\r\n                color: #000;\r\n                margin: 40px 0 10px;\r\n                line-height: 1.2;\r\n                font-weight: 200;\r\n            }\r\n\r\n            h1 {\r\n                font-size: 36px;\r\n            }\r\n            h2 {\r\n                font-size: 28px;\r\n            }\r\n            h3 {\r\n                font-size: 22px;\r\n            }\r\n\r\n            p, ul, ol {\r\n                margin-bottom: 10px;\r\n                font-weight: normal;\r\n                font-size: 14px;\r\n            }\r\n\r\n            ul li, ol li {\r\n                margin-left: 5px;\r\n                list-style-position: inside;\r\n            }\r\n\r\n            /* ---------------------------------------------------\r\n                            RESPONSIVENESS\r\n                            Nuke it from orbit. It\'s the only way to be sure.\r\n            ------------------------------------------------------ */\r\n\r\n            /* Set a max-width, and make it display as block so it will automatically stretch to that width, but will also shrink down on a phone or something */\r\n            .container {\r\n                display: block!important;\r\n                max-width: 600px!important;\r\n                margin: 0 auto!important; /* makes it centered */\r\n                clear: both!important;\r\n            }\r\n\r\n            /* Set the padding on the td rather than the div for Outlook compatibility */\r\n            .body-wrap .container {\r\n                padding: 20px;\r\n            }\r\n\r\n            /* This should also be a block element, so that it will fill 100% of the .container */\r\n            .content {\r\n                max-width: 600px;\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n\r\n            /* Let\'s make sure tables in the content area are 100% wide */\r\n            .content table {\r\n                width: 100%;\r\n            }\r\n\r\n        </style>\r\n    </head>\r\n\r\n    <body bgcolor=\"#f6f6f6\">\r\n\r\n        <!-- body -->\r\n        <table class=\"body-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\" bgcolor=\"#FFFFFF\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td>\r\n                                    <p>{%username} Ø¹Ø²ÛŒØ² Ù«</p>\r\n                                                                        <p>\r\nØ§ÛŒÙ† Ø§ÛŒÙ…ÛŒÙ„ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ Ø´Ù…Ø§ Ø§Ø² Ù…Ø´Ø®ØµØ§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª\r\n                                    </p>\r\n                                    <p>\r\n                                        Ù…Ø´Ø®ØµØ§Øª ÙˆØ±ÙˆØ¯ \r\n                                        <br/>\r\n                                        Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ : {%username}\r\n                                        <br/>\r\n                                        Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± : {%password}\r\n                                    </p>\r\n                                    <hr/>\r\n                                    <p>\r\nØ¬Ù‡Øª Ø§ÛŒØ¬Ø§Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù« ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ù« Ù„ÛŒØ³Øª Ú©Ø§Ø¨Ø±Ø§Ù† Ù…Ù†Ù‚Ø¶ÛŒ Ùˆ Ø§ÛŒØ¬Ø§Ø¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§Ø®ØªØµØ§ØµÛŒ ÙˆØ§Ø±Ø¯ Ù…Ø­ÛŒØ· {%level_string} Ø´ÙˆÛŒØ¯\r\n                                    </p>\r\n                                    <table>\r\n                                        <tr>\r\n                                            <td class=\"padding\">\r\n                                                <p><a href=\"{%app_url}\" class=\"btn-primary\">ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù…Ø­ÛŒØ· {%level_string}</a></p>\r\n                                            </td>\r\n                                        </tr>\r\n                                    </table>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /body -->\r\n\r\n        <!-- footer -->\r\n        <table class=\"footer-wrap\">\r\n            <tr>\r\n                <td></td>\r\n                <td class=\"container\">\r\n\r\n                    <!-- content -->\r\n                    <div class=\"content\">\r\n                        <table>\r\n                            <tr>\r\n                                <td align=\"center\">\r\n                                    <p>\r\n                                        <a href=\"http://persistpanel.com\" target=\"_blank\">\r\n                                            PersistPanel.com\r\n                                        </a>\r\n                                    </p>\r\n                                </td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                    <!-- /content -->\r\n\r\n                </td>\r\n                <td></td>\r\n            </tr>\r\n        </table>\r\n        <!-- /footer -->\r\n\r\n    </body>\r\n</html>');
COMMIT;

-- ----------------------------
--  Table structure for `file`
-- ----------------------------
DROP TABLE IF EXISTS `file`;
CREATE TABLE `file` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `guide` text,
  `icon` varchar(255) DEFAULT NULL,
  `binary` varchar(255) DEFAULT NULL,
  `config` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `invoice`
-- ----------------------------
DROP TABLE IF EXISTS `invoice`;
CREATE TABLE `invoice` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `number` int(11) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `paid_date` timestamp NULL DEFAULT NULL,
  `gateway` varchar(255) DEFAULT NULL,
  `username` varchar(255) DEFAULT NULL,
  `level` varchar(255) DEFAULT NULL,
  `amount` int(11) DEFAULT NULL,
  `description` text,
  `action` text,
  `status` varchar(255) DEFAULT NULL,
  `transaction` text,
  `processed` int(1) DEFAULT '0',
  `reseller_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `module`
-- ----------------------------
DROP TABLE IF EXISTS `module`;
CREATE TABLE `module` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `install` int(1) DEFAULT '0',
  `active` int(1) DEFAULT '0',
  `data` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `package`
-- ----------------------------
DROP TABLE IF EXISTS `package`;
CREATE TABLE `package` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `acc_name` varchar(255) DEFAULT NULL,
  `css_tag` text,
  `description` text,
  `price_1` int(11) DEFAULT NULL,
  `price_2` int(11) DEFAULT NULL,
  `period` int(11) DEFAULT NULL,
  `traffic` int(11) DEFAULT NULL,
  `visible` int(1) DEFAULT '1',
  `reseller` int(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
--  Records of `package`
-- ----------------------------
BEGIN;
INSERT INTO `package` VALUES ('1', 'Ù¾ÛŒØ´ ÙØ±Ø¶', '', null, 'Ù¾Ú©ÛŒØ¬ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÛŒØ³ØªÙ…\r\n<br>\r\nØ¨Ø¹Ø¯ Ø§Ø² Ù†ØµØ¨ Ø§ÛŒÙ† Ù¾Ú©ÛŒØ¬ Ø±Ø§ Ø­Ø°Ù Ùˆ Ø§Ù‚Ø¯Ø§Ù… Ø¨Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ù¾Ú©ÛŒØ¬ Ù‡Ø§ÛŒ Ø®ÙˆØ¯ Ù†Ù…Ø§ÛŒÛŒØ¯', '10000000', '5000000', '365', '1', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `queue`
-- ----------------------------
DROP TABLE IF EXISTS `queue`;
CREATE TABLE `queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ibsid` int(11) DEFAULT NULL,
  `username` varchar(255) DEFAULT NULL,
  `acc_name` varchar(255) DEFAULT NULL,
  `credit` int(11) DEFAULT NULL,
  `creation` timestamp NULL DEFAULT NULL,
  `relexpdate` varchar(255) DEFAULT NULL,
  `lock` int(11) DEFAULT NULL,
  `package_id` int(11) DEFAULT NULL,
  `reseller_id` int(11) DEFAULT NULL,
  `transfered` int(1) DEFAULT '0',
  `sync_date` timestamp NULL DEFAULT NULL,
  `shown` int(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `reports`
-- ----------------------------
DROP TABLE IF EXISTS `reports`;
CREATE TABLE `reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) DEFAULT NULL,
  `result` text,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `duration` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=latin1;

-- ----------------------------
--  Records of `reports`
-- ----------------------------
BEGIN;
INSERT INTO `reports` VALUES ('14', 'cron_last_run', 'runned', '2015-09-13 14:08:01', '0'), ('15', 'auto_sync', 'done', '2015-09-12 15:32:24', '0'), ('16', 'service_monitor', 'a:3:{s:3:\"acc\";b:1;s:4:\"smtp\";b:1;s:7:\"payment\";b:1;}', '2015-09-13 14:12:28', '0'), ('25', 'backup_cron', 'done', '2015-09-13 12:00:02', '1'), ('18', 'sync_loop', 'done', '2015-09-13 14:16:15', '733'), ('19', 'ibsng_loop', 'done', '2015-09-13 14:16:16', '1');
COMMIT;

-- ----------------------------
--  Table structure for `reseller`
-- ----------------------------
DROP TABLE IF EXISTS `reseller`;
CREATE TABLE `reseller` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fullname` varchar(255) DEFAULT NULL,
  `username` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `credit` int(11) DEFAULT NULL,
  `prefix` varchar(4) DEFAULT NULL,
  `lastlogin` timestamp NULL DEFAULT NULL,
  `registered` timestamp NULL DEFAULT NULL,
  `logo` text,
  `shopname` varchar(255) DEFAULT NULL,
  `shoptitle` varchar(255) DEFAULT NULL,
  `passreq` varchar(255) DEFAULT NULL,
  `passreq_time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `reseller_gateway`
-- ----------------------------
DROP TABLE IF EXISTS `reseller_gateway`;
CREATE TABLE `reseller_gateway` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `reseller_id` int(11) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `data` text,
  `active` int(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `reseller_pricing`
-- ----------------------------
DROP TABLE IF EXISTS `reseller_pricing`;
CREATE TABLE `reseller_pricing` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `reseller_id` int(11) DEFAULT NULL,
  `package_id` int(11) DEFAULT NULL,
  `price` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `sync_config`
-- ----------------------------
DROP TABLE IF EXISTS `sync_config`;
CREATE TABLE `sync_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `auto_sync` int(1) DEFAULT '1',
  `smart_resellers` int(1) DEFAULT '0',
  `default_package` int(11) DEFAULT NULL,
  `ignore_sync` text,
  `sync_interval` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
--  Records of `sync_config`
-- ----------------------------
BEGIN;
INSERT INTO `sync_config` VALUES ('1', '1', '1', '1', '', '60');
COMMIT;

-- ----------------------------
--  Table structure for `ticket`
-- ----------------------------
DROP TABLE IF EXISTS `ticket`;
CREATE TABLE `ticket` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `username` varchar(255) DEFAULT NULL,
  `level` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `subject` varchar(255) DEFAULT NULL,
  `body` text,
  `ip` varchar(255) DEFAULT NULL,
  `browser` varchar(255) DEFAULT NULL,
  `browserversion` varchar(255) DEFAULT NULL,
  `platform` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `status` varchar(255) DEFAULT NULL,
  `readdate` timestamp NULL DEFAULT NULL,
  `uniqueid` varchar(255) DEFAULT NULL,
  `priority` int(3) DEFAULT '2',
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `lastuser` varchar(255) DEFAULT NULL,
  `lastlevel` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `ticket_replies`
-- ----------------------------
DROP TABLE IF EXISTS `ticket_replies`;
CREATE TABLE `ticket_replies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tid` int(11) DEFAULT NULL,
  `message` text,
  `owner_level` varchar(255) DEFAULT NULL,
  `owner_username` varchar(255) DEFAULT NULL,
  `readdate` timestamp NULL DEFAULT '0000-00-00 00:00:00',
  `rate` int(5) DEFAULT '0',
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
--  Table structure for `user`
-- ----------------------------
DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `reseller_id` int(11) DEFAULT '0',
  `username` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `fullname` varchar(255) DEFAULT NULL,
  `note` text,
  `package_id` int(11) DEFAULT NULL,
  `registered` timestamp NULL DEFAULT NULL,
  `locked` int(1) DEFAULT '0',
  `expire_date` timestamp NULL DEFAULT NULL,
  `first_login` timestamp NULL DEFAULT NULL,
  `last_sync` timestamp NULL DEFAULT NULL,
  `credit` int(11) NOT NULL DEFAULT '0',
  `lastlogin` timestamp NULL DEFAULT NULL,
  `lastnotified` timestamp NULL DEFAULT '0000-00-00 00:00:00',
  `passreq_time` timestamp NULL DEFAULT NULL,
  `passreq` varchar(255) DEFAULT NULL,
  `lastlogout` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

SET FOREIGN_KEY_CHECKS = 1;
